# BEYOND_EUvsVirus
## About
This is the git repository of the participation of the BEYOND team at the EUvsVirus Hackathon organized by the European Commission.

## Inspiration
The Centre of Earth Observation Research and Satellite Remote Sensing BEYOND (http://beyond-eocenter.eu/index.php) of the National Observatory of Athens is a research unit mandated to conduct innovative research in the fields of Earth Observation, Data Science, Environmental and Epidemiological modeling, and multi-source data fusion.  BEYOND has been developing research to address societal priorities. and has been delivering services that are beneficial in different domains emphasizing mostly in crisis management, civil protection, food security, business resilience, citizen, natural, and urban environmental protection. The higher TRL services are offered in support of various sectors and policy needs such as Health, Food, Energy, Sustainable Development in-line to Agenda 2030, and Disasters Management in compliance with the priorities set by the Shedai Framework. BEYOND acts as Regional Support Office of UN-SPIDER for Disaster Management, is a validated partner of Copernicus EMS for Crisis Risk Assessment and Recovery, and is the selected GEO partner for coordinating EO and Copernicus in the neighboring EU regions namely N. Africa, Middle East, Balkans, and the Black Sea for Emergency Response, Agriculture, Renewable Energy, and environmentally friendly Raw Materials exploitation.  
BEYOND as part of its mandate has been actively participating to combat the COVID-19 pandemic since the early days of the pandemic outbreaks. All our actions aim to offer an integrated Risk Assessment and Early Warning Web ( http://webgiscovid19.beyond-eocenter.eu/ ) portal leveraging official human case data, in-situ, media, and space derived parameters and assure applicability at various scales (global, national, regional, city/municipality) through direct connectivity with APIs to Official portals as ECDC, WHO, Institutional and International Health, and Civil Protection Agencies, Professions, and the general public. The platform systematically monitors the global spread of the pandemic and has been constantly expanding its functionality by integrating and combining different data sources and data analysis operations. The BEYOND's vision is to keep enhancing the platform and contribute with its work to minimize the societal and economic impact of COVID-19 pandemic by delivering a system that supports the enhanced decision and policymaking across the entire value-added chain.
## What it does
As referenced herein the project's wider scope is to develop a solid, multi-source risk assessment and timely reporting system by offering the integrated COVID-19 Web portal. It is based on open source technologies and advanced data manipulation for handling multiple source data fusion such as in-situ, official public health data, social media, and press data, as well as environmental, and atmospheric parameters, and big space EO  and EO derived proxies that are essential for the human health parameters. It enables the participation of national authorities and public administration to provide validated information on the pandemic, allowing more fine-grained and deeper level of analysis of the pandemic at NUTS3 and greater. It delivers daily data with up to date statistics normalized at the population level and at various scales. It allows the comparison between the different countries and highlights the importance of the anticipated policies and measures per country insights which are highly important to engaged stakeholders e.g. decision-makers, professional chambers, health industry, and researchers.
The relationships between the COVID-19 pandemic with environmental and seasonal related data namely specific humidity, relative humidity, and temperature, as well as the relations with atmospheric parameters that are essential for human health such as gas emissions, nitrogen oxides, carbon oxides, and fine particles are visualized. This is achieved through the connection to in-situ sensors network of the Atmospheric Group of National Observatory of Athens, but also the Copernicus Data Hubs, the Copernicus Core Service Portals, the Hellenic Mirror Site and other Copernicus Sites available in Europe, and the US National Centre of Environmental Prediction (NCEP). The prospect is to connect in the future to as many other available and useful data portals as needed by a risk assessment modeling.  
Moreover, the analysis of the atmospheric parameters allows us to identify behavioral patterns like the general engagement of people to lockdown but also during weekends, holidays, and good weather conditions that favor increased traffic for recreation and socialization. Such observations can be critical for the evaluation of measures and assist in further decision making with respect to the gradual return to normality.    
The platform's architecture ensures openness, interoperability, scalability, and responsiveness and enables the integration of scientific models towards the generation of early warnings and risk assessments.   
## How we built it
Initially, the backend connects with multiple sources' **APIs** using **Python**in order to harvest, download, and preprocess **automatically** the data. The processed data are stored in a **PostgreSQL/PostGIS** database giving the potential for **geospatial queries**. A purely open-source server, **GeoServer**, has been selected for creating map services. We mainly used **javascript** and **PHP** to develop the **front-end** of the platform. Interactive **maps** have been introduced via **Leaflet**, a JavaScript library. Finally, **Highcharts**, a JS library, has been used to create graphs and plots so to enhance **data visualization**.
## Challenges we ran into
 The main challenge we had to face was relating to the big and multiple data, the federated harvesting of meta-data from multiple portals using open standards, the downloading and mass processing of historic series of meteorological and environmental data, the daily derivation of modeled parameters, the handling of the big satellite Sentinel-5P data, and last but not least the analysis of a vast variety of sources. Due to the different formats of the data, we used MySQL to handle the meteorological data in grib format and the PostgreSQL to handle the raster data. 
## Accomplishments that we're proud of
To complement and enhance the existing domains of knowledge on the COVID-19 impact, by allowing the authorized users, official Health Authorities, Civil Protection Organisations, and Municipality/Regional Authorities to gain access and easily upload new fine-grained data on a larger topographic scale e.g. municipality level, which in turn enhances the development of a reliable risk assessment system.
## What's next for BEYOND - A Covid-19 Risk Assessment Web Platform
Our utmost priority is to use this new risk assessment platform in a way to illuminate our current knowledge and understanding on the COVID-19 to a greater extent, through the dynamic ingestion and analysis of big data, and decode and model with a dynamic and AI approaches the seasonal aspect of the outbreaks.
The proposed data ingestion will be applied at larger scales, showcasing the scalability of the overall system. Thus, the integration of the database with additional data can trigger the creation of big data analytics such as alert mechanisms and improvement of decision making.

